// BMView.cpp : implementation of the CBMView class
//

#include "stdafx.h"

#include "BMDoc.h"
#include "BMView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CRect EmptyRect;

#define HANDLESIZE 4
/////////////////////////////////////////////////////////////////////////////
// CBMView

IMPLEMENT_DYNCREATE(CBMView, CView)

BEGIN_MESSAGE_MAP(CBMView, CView)
	//{{AFX_MSG_MAP(CBMView)
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_OPTIONS_NEGX, OnOptionsNegx)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_NEGX, OnUpdateOptionsNegx)
	ON_COMMAND(ID_OPTIONS_NEGY, OnOptionsNegy)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_NEGY, OnUpdateOptionsNegy)
	ON_COMMAND(ID_OPTIONS_NEGZ, OnOptionsNegz)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_NEGZ, OnUpdateOptionsNegz)
	ON_COMMAND(ID_OPTIONS_POSX, OnOptionsPosx)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_POSX, OnUpdateOptionsPosx)
	ON_COMMAND(ID_OPTIONS_POSY, OnOptionsPosy)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_POSY, OnUpdateOptionsPosy)
	ON_COMMAND(ID_OPTIONS_POSZ, OnOptionsPosz)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_POSZ, OnUpdateOptionsPosz)
	ON_COMMAND(ID_OPTION_USE_EXCLUSION, OnOptionUseExclusion)
	ON_UPDATE_COMMAND_UI(ID_OPTION_USE_EXCLUSION, OnUpdateOptionUseExclusion)
	ON_COMMAND(ID_GENERATE_CM, OnGenerateCm)
	ON_UPDATE_COMMAND_UI(ID_GENERATE_CM, OnUpdateGenerateCm)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBMView construction/destruction

CBMView::CBMView()
{
	CWinApp *theApp;
	m_LbuttonDown = FALSE;
	m_bRectPlaced = FALSE;

	// load in cursors for us

	theApp = AfxGetApp();
	cursors[TOPLEFT] = cursors[BOTTOMRIGHT] = theApp->LoadStandardCursor(IDC_SIZENWSE);
	cursors[TOPMIDDLE] = cursors[BOTTOMMIDDLE] = theApp->LoadStandardCursor(IDC_SIZENS);
	cursors[TOPRIGHT] = cursors[BOTTOMLEFT] = theApp->LoadStandardCursor(IDC_SIZENESW);
	cursors[LEFTMIDDLE] = cursors[RIGHTMIDDLE] = theApp->LoadStandardCursor(IDC_SIZEWE);
	cursors[MOVE] = theApp->LoadStandardCursor(IDC_SIZEALL);
	m_OldCursor = GetCursor();

	m_HandleTracking = UNDEFINEDHANDLE;
	m_UseExclusion = FALSE;
	EmptyRect.SetRectEmpty();
	m_OldSize.cx = m_OldSize.cy = 0;
	m_OldDiffX = 0.0f;
	m_OldDiffY = 0.0f;
	m_fIncSizeRect.left = 0.0f;
	m_fIncSizeRect.right = 0.0f;
	m_fIncSizeRect.top = 0.0f;
	m_fIncSizeRect.bottom = 0.0f;
	m_fExcSizeRect.left = 0.0f;
	m_fExcSizeRect.right = 0.0f;
	m_fExcSizeRect.top = 0.0f;
	m_fExcSizeRect.bottom = 0.0f;
}

CBMView::~CBMView()
{
}

BOOL CBMView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBMView drawing

void CBMView::OnDraw(CDC* pDC)
{
	BITMAP bitmapInfo;
	CRect cRect;
	CDC memDC;
	CBitmap *oldBitmap;

	CBMDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// Scale image into window for now
	memDC.CreateCompatibleDC(NULL);
	oldBitmap = memDC.SelectObject(&pDoc->m_TheBitmap);

	pDoc->m_TheBitmap.GetBitmap(&bitmapInfo);
	GetClientRect(cRect);

	pDC->SetStretchBltMode(COLORONCOLOR);
	pDC->StretchBlt(cRect.left, cRect.top, cRect.Width(), cRect.Height(), &memDC,
		0, 0, bitmapInfo.bmWidth, bitmapInfo.bmHeight, SRCCOPY);

	if (m_bRectPlaced)
	{
		DrawSelections();
	}

	memDC.SelectObject(oldBitmap);
}

/////////////////////////////////////////////////////////////////////////////
// CBMView printing

BOOL CBMView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CBMView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CBMView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CBMView diagnostics

#ifdef _DEBUG
void CBMView::AssertValid() const
{
	CView::AssertValid();
}

void CBMView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBMDoc* CBMView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBMDoc)));
	return (CBMDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBMView message handlers

BOOL CBMView::OnEraseBkgnd(CDC* pDC) 
{	
	return TRUE;
}

int CBMView::CheckMouseOverHandles(const CRect &theRect, CPoint mousePos)
{
	CRect temp;
	temp.SetRect(theRect.TopLeft(), theRect.TopLeft());
	temp.InflateRect(CSize(HANDLESIZE, HANDLESIZE));
	if (temp.PtInRect(mousePos))
		return TOPLEFT;

	temp.SetRect(theRect.left + (theRect.Width()/2), theRect.top,
		theRect.left + (theRect.Width()/2), theRect.top);
	temp.InflateRect(CSize(HANDLESIZE, HANDLESIZE));
	if (temp.PtInRect(mousePos))
		return TOPMIDDLE;

	temp.SetRect(theRect.right, theRect.top, theRect.right, theRect.top);
	temp.InflateRect(CSize(HANDLESIZE, HANDLESIZE));
	if (temp.PtInRect(mousePos))
		return TOPRIGHT;

	temp.SetRect(theRect.right, theRect.top + (theRect.Height()/2),
		theRect.right, theRect.top + (theRect.Height()/2));
	temp.InflateRect(CSize(HANDLESIZE,HANDLESIZE));
	if (temp.PtInRect(mousePos))
		return RIGHTMIDDLE;

	temp.SetRect(theRect.BottomRight(), theRect.BottomRight());
	temp.InflateRect(CSize(HANDLESIZE, HANDLESIZE));
	if (temp.PtInRect(mousePos))
		return BOTTOMRIGHT;

	temp.SetRect(theRect.left + (theRect.Width()/2), theRect.bottom,
					theRect.left + (theRect.Width()/2), theRect.bottom);
	temp.InflateRect(CSize(HANDLESIZE,HANDLESIZE));
	if (temp.PtInRect(mousePos))
		return BOTTOMMIDDLE;

	temp.SetRect(theRect.left, theRect.bottom,
					theRect.left, theRect.bottom);
	temp.InflateRect(CSize(HANDLESIZE,HANDLESIZE));
	if (temp.PtInRect(mousePos))
		return BOTTOMLEFT;

	temp.SetRect(theRect.left, theRect.top + (theRect.Height()/2),
		theRect.left, theRect.top + (theRect.Height()/2));
	temp.InflateRect(CSize(HANDLESIZE,HANDLESIZE));
	if (temp.PtInRect(mousePos))
		return LEFTMIDDLE;

	return UNDEFINEDHANDLE;
}

void CBMView::DrawHandles(CDC *pDC, const CRect &theRect)
{
	CRect temp;

	temp.SetRect(theRect.TopLeft(), theRect.TopLeft());
	temp.InflateRect(CSize(HANDLESIZE, HANDLESIZE));
	pDC->Rectangle(temp);

	temp.SetRect(theRect.left + (theRect.Width()/2), theRect.top,
		theRect.left + (theRect.Width()/2), theRect.top);
	temp.InflateRect(CSize(HANDLESIZE, HANDLESIZE));
	pDC->Rectangle(temp);

	temp.SetRect(theRect.right, theRect.top, theRect.right, theRect.top);
	temp.InflateRect(CSize(HANDLESIZE, HANDLESIZE));
	pDC->Rectangle(temp);

	temp.SetRect(theRect.right, theRect.top + (theRect.Height()/2),
		theRect.right, theRect.top + (theRect.Height()/2));
	temp.InflateRect(CSize(HANDLESIZE,HANDLESIZE));
	pDC->Rectangle(temp);

	temp.SetRect(theRect.BottomRight(), theRect.BottomRight());
	temp.InflateRect(CSize(HANDLESIZE, HANDLESIZE));
	pDC->Rectangle(temp);

	temp.SetRect(theRect.left + (theRect.Width()/2), theRect.bottom,
					theRect.left + (theRect.Width()/2), theRect.bottom);
	temp.InflateRect(CSize(HANDLESIZE,HANDLESIZE));
	pDC->Rectangle(temp);

	temp.SetRect(theRect.left, theRect.bottom,
					theRect.left, theRect.bottom);
	temp.InflateRect(CSize(HANDLESIZE,HANDLESIZE));
	pDC->Rectangle(temp);

	temp.SetRect(theRect.left, theRect.top + (theRect.Height()/2),
		theRect.left, theRect.top + (theRect.Height()/2));
	temp.InflateRect(CSize(HANDLESIZE,HANDLESIZE));
	pDC->Rectangle(temp);

}
void CBMView::DrawSelections()
{
	POINT polyPoints[5];
	CDC *pDC;
	CPen greenPen(PS_SOLID, 3, RGB(0, 255, 0));
	CPen redPen(PS_SOLID, 3, RGB(255, 0, 0));
	CBrush blackBrush(RGB(0,0,0));
	CPen *oldPen;
	CBrush *oldBrush;
	int oldRop;
	CRect theRect;

	pDC = GetDC();
	oldPen = pDC->SelectObject(&redPen);
	oldBrush = pDC->SelectObject(&blackBrush);

	if (m_bRectPlaced)
	{
		oldRop = pDC->SetROP2(R2_COPYPEN);
		m_CenterPoint = m_IncludeEllipseRect.CenterPoint();
	}
	else
	{
		oldRop = pDC->SetROP2(R2_XORPEN);
	}

	if (m_UseExclusion)
	{

		polyPoints[0] = m_ExcludeEllipseRect.TopLeft();
		polyPoints[1].x = m_ExcludeEllipseRect.right;
		polyPoints[1].y = m_ExcludeEllipseRect.top;
		polyPoints[2] = m_ExcludeEllipseRect.BottomRight();
		polyPoints[3].x = m_ExcludeEllipseRect.left;
		polyPoints[3].y = m_ExcludeEllipseRect.bottom;
		polyPoints[4] = m_ExcludeEllipseRect.TopLeft();
		pDC->Polyline(polyPoints, 5);

		pDC->Arc(m_ExcludeEllipseRect, m_ExcludeEllipseRect.TopLeft(), 
					m_ExcludeEllipseRect.TopLeft());

		// draw dragging squares
		if (m_bRectPlaced)
		{
			DrawHandles(pDC, m_ExcludeEllipseRect);
		}
	}

	// this is drawn last as it is will be on top for
	// the hittest to match
	pDC->SelectObject(&greenPen);

	polyPoints[0] = m_IncludeEllipseRect.TopLeft();
	polyPoints[1].x = m_IncludeEllipseRect.right;
	polyPoints[1].y = m_IncludeEllipseRect.top;
	polyPoints[2] = m_IncludeEllipseRect.BottomRight();
	polyPoints[3].x = m_IncludeEllipseRect.left;
	polyPoints[3].y = m_IncludeEllipseRect.bottom;
	polyPoints[4] = m_IncludeEllipseRect.TopLeft();
	pDC->Polyline(polyPoints, 5);
	pDC->Arc(m_IncludeEllipseRect, m_IncludeEllipseRect.TopLeft(), m_IncludeEllipseRect.TopLeft());

	// draw dragging squares
	if (m_bRectPlaced)
	{
		DrawHandles(pDC, m_IncludeEllipseRect);
	}

	pDC->SelectObject(oldBrush);
	pDC->SelectObject(oldPen);
	pDC->SetROP2(oldRop);
}

void CBMView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int handleIn;
	if (m_bRectPlaced)
	{
		m_bRectPlaced = FALSE;
		RedrawWindow();
	}

	m_LbuttonDown = TRUE;
	handleIn = HitTest(point);
	if (handleIn == UNDEFINEDHANDLE)
	{
		m_IncludeEllipseRect.SetRect(point, point);
		m_ExcludeEllipseRect = m_IncludeEllipseRect;
		m_ExcludeEllipseRect.DeflateRect((m_ExcludeEllipseRect.Width()/8)*3,
				(m_ExcludeEllipseRect.Height()/8)*3);
		m_HandleTracking = UNDEFINEDHANDLE;
	}
	else
	{
		m_HandleTracking = handleIn;
		m_MouseStart = point;
	}

	DrawSelections();
	
	CView::OnLButtonDown(nFlags, point);
}

void CBMView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_LbuttonDown)
	{
		// erase selections
		DrawSelections();

		if (!m_IncludeEllipseRect.IsRectEmpty())
		{
			m_bRectPlaced = TRUE;
			// permanently put down the rectangle
			DrawSelections();
		}
	}

	m_LbuttonDown = FALSE;
	
	CView::OnLButtonUp(nFlags, point);
}

int CBMView::HitTest(CPoint point) 
{
	int handleIn;
	handleIn = CheckMouseOverHandles(m_IncludeEllipseRect, point);
	if (handleIn != UNDEFINEDHANDLE)
	{
		return handleIn;
	}

	if (m_UseExclusion)
	{
		handleIn= CheckMouseOverHandles(m_ExcludeEllipseRect, point);
		if (handleIn != UNDEFINEDHANDLE)
		{
			return handleIn | 0x8000;
		}
	}

	// if in include rectangle then move the rectangle
	if (m_IncludeEllipseRect.PtInRect(point))
	{
		m_MouseStart = point;
		return MOVE;
	}

	return UNDEFINEDHANDLE;
}

void CBMView::DeflateInner(CPoint diff, CPoint mousePos)
{
	CRect newExRect;

	newExRect = m_ExcludeEllipseRect;
	newExRect.DeflateRect(diff.x, diff.y);
	if ((newExRect.left < newExRect.right) && (newExRect.top < newExRect.bottom))
	{
		newExRect.IntersectRect(newExRect, m_IncludeEllipseRect);
		if (newExRect != m_IncludeEllipseRect)
		{
			// erase rectangle
			DrawSelections();
			m_ExcludeEllipseRect = newExRect;
			m_MouseStart = mousePos;
			DrawSelections();
		}
	}
}

void CBMView::DeflateOuter(CRect diff, CPoint mousePos)
{
	CRect newRect;
	CRect newExRect;

	newRect = m_IncludeEllipseRect;
	newRect.DeflateRect(diff.left, diff.top, diff.right, diff.bottom);

	if ((newRect.left < newRect.right) && (newRect.top < newRect.bottom))
	{
		newExRect = m_ExcludeEllipseRect;
		// center new exclusion ellipse in inclusion ellipse
		newExRect.OffsetRect(newRect.CenterPoint() -
			m_ExcludeEllipseRect.CenterPoint());
		newRect.UnionRect(newRect, m_ExcludeEllipseRect);

		if (newRect != m_ExcludeEllipseRect)
		{
			// erase rectangle
			DrawSelections();
			m_IncludeEllipseRect = newRect;
			m_ExcludeEllipseRect = newExRect;
			m_MouseStart = mousePos;
			DrawSelections();
		}
	}
}

void CBMView::OnMouseMove(UINT nFlags, CPoint point) 
{
	int handleIn;
	CPoint diff;

	if (m_LbuttonDown && !m_bRectPlaced)
	{

		if (m_HandleTracking == UNDEFINEDHANDLE)
		{
			// xor rectangle off
			DrawSelections();
			m_IncludeEllipseRect.right = point.x;
			m_IncludeEllipseRect.bottom = point.y;
			m_ExcludeEllipseRect = m_IncludeEllipseRect;
			m_ExcludeEllipseRect.DeflateRect((m_IncludeEllipseRect.Width()/8)*3,
				(m_IncludeEllipseRect.Height()/8)*3);
			DrawSelections();
		}
		else
		{
			switch (m_HandleTracking & ~0x8000)
			{
			case MOVE:
				// xor rectangle off
				DrawSelections();
				m_MouseStart = point - m_MouseStart;
				m_IncludeEllipseRect.OffsetRect(m_MouseStart);
				m_ExcludeEllipseRect.OffsetRect(m_MouseStart);
				m_MouseStart = point;
				DrawSelections();
				break;
			case TOPLEFT:
				if (m_HandleTracking & 0x8000)
				{
					diff = point - m_MouseStart;
					DeflateInner(diff, point);
				}
				else
				{
					diff = point - m_MouseStart;
					DeflateOuter(CRect(diff.x, diff.y, 0, 0), point);
				}
				break;
			case TOPMIDDLE:
				if (m_HandleTracking & 0x8000)
				{
					diff = point - m_MouseStart;
					diff.x = 0;
					DeflateInner(diff, point);
				}
				else
				{
					diff = point - m_MouseStart;
					DeflateOuter(CRect(0, diff.y, 0, 0), point);
				}
				break;
			case TOPRIGHT:
				if (m_HandleTracking & 0x8000)
				{
					diff = point - m_MouseStart;
					diff.x = -diff.x;
					DeflateInner(diff, point);
				}
				else
				{
					diff = point - m_MouseStart;
					DeflateOuter(CRect(0, diff.y, -diff.x, 0), point);
				}
				break;
			case RIGHTMIDDLE:
				if (m_HandleTracking & 0x8000)
				{
					diff = point - m_MouseStart;
					diff.x = -diff.x;
					diff.y = 0;
					DeflateInner(diff, point);
				}
				else
				{
					diff = point - m_MouseStart;
					DeflateOuter(CRect(0, 0, -diff.x, 0), point);
				}
				break;
			case BOTTOMRIGHT:
				if (m_HandleTracking & 0x8000)
				{
					diff = -(point - m_MouseStart);
					DeflateInner(diff, point);
				}
				else
				{
					diff = point - m_MouseStart;
					DeflateOuter(CRect(0, 0, -diff.x, -diff.y), point);
				}
				break;
			case BOTTOMMIDDLE:
				if (m_HandleTracking & 0x8000)
				{
					diff = point - m_MouseStart;
					diff.x = 0;
					diff.y = -diff.y;
					DeflateInner(diff, point);
				}
				else
				{
					diff = point - m_MouseStart;
					DeflateOuter(CRect(0, 0, 0, -diff.y), point);
				}
				break;
			case BOTTOMLEFT:
				if (m_HandleTracking & 0x8000)
				{
					diff = point - m_MouseStart;
					diff.y = -diff.y;
					DeflateInner(diff, point);
				}
				else
				{
					diff = point - m_MouseStart;
					DeflateOuter(CRect(diff.x, 0, 0, -diff.y), point);
				}
				break;
			case LEFTMIDDLE:
				if (m_HandleTracking & 0x8000)
				{
					diff = point - m_MouseStart;
					diff.y = 0;
					DeflateInner(diff, point);
				}
				else
				{
					diff = point - m_MouseStart;
					DeflateOuter(CRect(diff.x, 0, 0, 0), point);
				}
				break;
			}
		}

		CView::OnMouseMove(nFlags, point);
		return;
	}

	if (m_bRectPlaced)
	{
		handleIn = (HitTest(point));
		if (handleIn != UNDEFINEDHANDLE)
		{
			SetCursor(cursors[handleIn & ~0x8000]);
		}
		else
		{
			SetCursor(m_OldCursor);
		}

	}

	CView::OnMouseMove(nFlags, point);

}

void CBMView::OnOptionsNegx() 
{
	GetDocument()->m_CubeDir = CUBEMAP_NEG_X;
}

void CBMView::OnUpdateOptionsNegx(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
	pCmdUI->SetCheck(GetDocument()->m_CubeDir == CUBEMAP_NEG_X ? 1 : 0);
}

void CBMView::OnOptionsNegy() 
{
	GetDocument()->m_CubeDir = CUBEMAP_NEG_Y;
}

void CBMView::OnUpdateOptionsNegy(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
	pCmdUI->SetCheck(GetDocument()->m_CubeDir == CUBEMAP_NEG_Y ? 1 : 0);
}

void CBMView::OnOptionsNegz() 
{
	GetDocument()->m_CubeDir = CUBEMAP_NEG_Z;
}

void CBMView::OnUpdateOptionsNegz(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
	pCmdUI->SetCheck(GetDocument()->m_CubeDir == CUBEMAP_NEG_Z ? 1 : 0);
}

void CBMView::OnOptionsPosx() 
{
	GetDocument()->m_CubeDir = CUBEMAP_POS_X;
}

void CBMView::OnUpdateOptionsPosx(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
	pCmdUI->SetCheck(GetDocument()->m_CubeDir == CUBEMAP_POS_X ? 1 : 0);
}

void CBMView::OnOptionsPosy() 
{
	GetDocument()->m_CubeDir = CUBEMAP_POS_Y;	
}

void CBMView::OnUpdateOptionsPosy(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
	pCmdUI->SetCheck(GetDocument()->m_CubeDir == CUBEMAP_POS_Y ? 1 : 0);
}

void CBMView::OnOptionsPosz() 
{
	GetDocument()->m_CubeDir = CUBEMAP_POS_Z;
}

void CBMView::OnUpdateOptionsPosz(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
	pCmdUI->SetCheck(GetDocument()->m_CubeDir == CUBEMAP_POS_Z ? 1 : 0);
}

void CBMView::OnOptionUseExclusion() 
{
	m_UseExclusion = !m_UseExclusion;
	RedrawWindow();
}

void CBMView::OnUpdateOptionUseExclusion(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
	pCmdUI->SetCheck(m_UseExclusion ? 1 : 0);
	
}

void CBMView::OnGenerateCm() 
{
	theApp.m_pCMDocTemplate->OpenDocumentFile(NULL);
}

void CBMView::OnUpdateGenerateCm(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();	
}

CRect *CBMView::GetIncludeEllipseRect()
{
	if (m_bRectPlaced)
	{
		return &m_IncludeEllipseRect;
	}

	return &EmptyRect;
}


CRect *CBMView::GetExcludeEllipseRect()
{
	if (m_bRectPlaced && m_UseExclusion)
	{
		return &m_ExcludeEllipseRect;
	}

	return &EmptyRect;
}

void CBMView::OnInitialUpdate() 
{
	float aspect;
	CBMDoc *pDoc;
	BITMAP bi;
	CRect rect;

	pDoc = GetDocument();

	GetClientRect(rect);
	pDoc->m_TheBitmap.GetBitmap(&bi);
	aspect = ((float)(bi.bmWidth) / (float)(bi.bmHeight));

	if (aspect > 1.0f)
	{
		if (((float)rect.Width() * aspect) >= (float)rect.Height())
		{
			rect.right = rect.top + (DWORD)((float)rect.Height() * aspect);
		}
		else
		{
			rect.bottom = rect.top + (DWORD)((float)rect.Width() / aspect);
		}
	}
	else
	{
		if (((float)rect.Height() / aspect) <= (float)rect.Width())
		{
			rect.right = rect.top + (DWORD)((float)rect.Height() * aspect);
		}
		else
		{
			rect.bottom = rect.top + (DWORD)((float)rect.Width() / aspect);
		}
	}

	GetParentFrame()->MoveWindow(rect);

	CView::OnInitialUpdate();
	
}

void CBMView::OnSize(UINT nType, int cx, int cy) 
{
	float scaleX;
	float scaleY;

	CView::OnSize(nType, cx, cy);

	if (m_bRectPlaced)
	{
		scaleX = ((float)cx / (float)m_OldSize.cx);
		scaleY = ((float)cy / (float)m_OldSize.cy);


		m_IncludeEllipseRect.left = (int)((float)m_IncludeEllipseRect.left * scaleX) +
			(int)m_fIncSizeRect.left;
		m_IncludeEllipseRect.right = (int)((float)m_IncludeEllipseRect.right * scaleX) +
			(int)m_fIncSizeRect.right;
		m_IncludeEllipseRect.top = (int)((float)m_IncludeEllipseRect.top * scaleY) +
			(int)m_fIncSizeRect.top;
		m_IncludeEllipseRect.bottom = (int)((float)m_IncludeEllipseRect.bottom * scaleY) +
			(int)m_fIncSizeRect.bottom;

		m_fIncSizeRect.left = fmodf(m_fIncSizeRect.left, 1.0f);
		m_fIncSizeRect.right = fmodf(m_fIncSizeRect.right, 1.0f);
		m_fIncSizeRect.top = fmodf(m_fIncSizeRect.top, 1.0f);
		m_fIncSizeRect.bottom = fmodf(m_fIncSizeRect.bottom, 1.0f);

		m_fIncSizeRect.left += fmodf((float)m_IncludeEllipseRect.left * scaleX, 1.0f);
		m_fIncSizeRect.right += fmodf((float)m_IncludeEllipseRect.right * scaleX, 1.0f);
		m_fIncSizeRect.top += fmodf((float)m_IncludeEllipseRect.top * scaleY, 1.0f);
		m_fIncSizeRect.bottom += fmodf((float)m_IncludeEllipseRect.bottom * scaleY, 1.0f);

		m_ExcludeEllipseRect.left = (int)((float)m_ExcludeEllipseRect.left * scaleX) +
			(int)m_fExcSizeRect.left;
		m_ExcludeEllipseRect.right = (int)((float)m_ExcludeEllipseRect.right * scaleX) +
			(int)m_fExcSizeRect.right;
		m_ExcludeEllipseRect.top = (int)((float)m_ExcludeEllipseRect.top * scaleY) +
			(int)m_fExcSizeRect.top;
		m_ExcludeEllipseRect.bottom = (int)((float)m_ExcludeEllipseRect.bottom * scaleY) +
			(int)m_fExcSizeRect.bottom;

		m_fExcSizeRect.left = fmodf(m_fExcSizeRect.left, 1.0f);
		m_fExcSizeRect.right = fmodf(m_fExcSizeRect.right, 1.0f);
		m_fExcSizeRect.top = fmodf(m_fExcSizeRect.top, 1.0f);
		m_fExcSizeRect.bottom = fmodf(m_fExcSizeRect.bottom, 1.0f);

		m_fExcSizeRect.left += fmodf((float)m_ExcludeEllipseRect.left * scaleX, 1.0f);
		m_fExcSizeRect.right += fmodf((float)m_ExcludeEllipseRect.right * scaleX, 1.0f);
		m_fExcSizeRect.top += fmodf((float)m_ExcludeEllipseRect.top * scaleY, 1.0f);
		m_fExcSizeRect.bottom += fmodf((float)m_ExcludeEllipseRect.bottom * scaleY, 1.0f);
	}

	m_OldSize.cx = cx;
	m_OldSize.cy = cy;
}

