// BMView.h : interface of the CBMView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BMVIEW_H__F1A087FE_4BD8_4C46_BE2C_EE9DE76C96B1__INCLUDED_)
#define AFX_BMVIEW_H__F1A087FE_4BD8_4C46_BE2C_EE9DE76C96B1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define TOPLEFT			0
#define TOPMIDDLE		1
#define TOPRIGHT		2
#define RIGHTMIDDLE		3
#define BOTTOMRIGHT		4
#define BOTTOMMIDDLE	5
#define BOTTOMLEFT		6
#define LEFTMIDDLE		7
#define MOVE			8
#define NUMCURSORS		(MOVE+1)
#define UNDEFINEDHANDLE	-1

typedef struct _FRECT
{
	float	left;
	float	right;
	float	top;
	float	bottom;
} FRECT;

class CBMView : public CView
{
protected: // create from serialization only
	CBMView();
	DECLARE_DYNCREATE(CBMView)

// Attributes
public:
	CBMDoc* GetDocument();
	BOOL m_UseExclusion;

// Operations
public:
	CRect *GetIncludeEllipseRect();
	CRect *GetExcludeEllipseRect();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBMView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBMView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
// attributes
	CRect m_IncludeEllipseRect;
	CRect m_ExcludeEllipseRect;
	BOOL m_LbuttonDown;
	BOOL m_bRectPlaced;
	HCURSOR m_OldCursor;
	HCURSOR cursors[NUMCURSORS];
	int	m_HandleTracking;
	CPoint m_MouseStart;
	CSize m_OldSize;
	float m_OldDiffX;
	float m_OldDiffY;
	CPoint m_CenterPoint;
	FRECT m_fIncSizeRect;
	FRECT m_fExcSizeRect;


// Implementation
	void DrawSelections();
	void DrawHandles(CDC *pDC, const CRect &theRect);
	int CheckMouseOverHandles(const CRect &theRect, CPoint mousePos);
	int HitTest(CPoint point);
	void DeflateOuter(CRect diff, CPoint mousePos);
	void DeflateInner(CPoint diff, CPoint mousePos);


// Generated message map functions
protected:
	//{{AFX_MSG(CBMView)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnOptionsNegx();
	afx_msg void OnUpdateOptionsNegx(CCmdUI* pCmdUI);
	afx_msg void OnOptionsNegy();
	afx_msg void OnUpdateOptionsNegy(CCmdUI* pCmdUI);
	afx_msg void OnOptionsNegz();
	afx_msg void OnUpdateOptionsNegz(CCmdUI* pCmdUI);
	afx_msg void OnOptionsPosx();
	afx_msg void OnUpdateOptionsPosx(CCmdUI* pCmdUI);
	afx_msg void OnOptionsPosy();
	afx_msg void OnUpdateOptionsPosy(CCmdUI* pCmdUI);
	afx_msg void OnOptionsPosz();
	afx_msg void OnUpdateOptionsPosz(CCmdUI* pCmdUI);
	afx_msg void OnOptionUseExclusion();
	afx_msg void OnUpdateOptionUseExclusion(CCmdUI* pCmdUI);
	afx_msg void OnGenerateCm();
	afx_msg void OnUpdateGenerateCm(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BMView.cpp
inline CBMDoc* CBMView::GetDocument()
   { return (CBMDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BMVIEW_H__F1A087FE_4BD8_4C46_BE2C_EE9DE76C96B1__INCLUDED_)
