#if !defined(AFX_CUBEMAPDOC_H__29C9064E_ACE2_4A7D_AF94_E8ADA0230AAB__INCLUDED_)
#define AFX_CUBEMAPDOC_H__29C9064E_ACE2_4A7D_AF94_E8ADA0230AAB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CubeMapDoc.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCubeMapDoc document

class CCubeMapDoc : public CDocument
{
protected:
	CCubeMapDoc();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CCubeMapDoc)

// Attributes
public:
	CBitmap m_CubeFaces[CUBEMAP_TOTAL_DIR];
	DWORD m_CubeMapsFound;		// bits 1-CUBEMAP_TOTAL_DIR
	DWORD m_ExclusionPresent;	// bits 1-CUBEMAP_TOTAL_DIR is exclusion rectangle is present
	CSize m_CubeSize;
	BOOL m_DialogCanceled;

	CBMDoc *m_BitmapDocs[CUBEMAP_TOTAL_DIR];
	CBMView *m_BitmapViews[CUBEMAP_TOTAL_DIR];
	RGB *m_CubeFacesData[CUBEMAP_TOTAL_DIR];
	CRect *m_CubeIncludeEllipseRects[CUBEMAP_TOTAL_DIR];
	CRect *m_CubeExcludeEllipseRects[CUBEMAP_TOTAL_DIR];
	BOOL SampleCubeMap();
	D3DXVECTOR3 *GetCubeVector(DWORD face, const CPoint *pos, const CSize *size, 
			D3DXVECTOR3 *vecOut);
	D3DXVECTOR2 *GetSTCoordinates(DWORD face, const D3DXVECTOR3 *vecIn, 
			D3DXVECTOR2 *vecOut);
	void SampleTextures(DWORD index, const CPoint *pos, const CSize *srcSize, 
					ILubyte *tData[], const CRect *iRect, const CRgn *eRgn, 
					const CRgn *eBlendRgn, RGB *dest);
	D3DXVECTOR3 *m_CubeNormals[CUBEMAP_TOTAL_DIR];
	void BlendExclusion(DWORD index, const CPoint *pos, 
				const CSize *srcSize, const CRgn *eBlendRgn, RGB *dest);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCubeMapDoc)
	public:
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	protected:
	virtual BOOL OnNewDocument();
	virtual BOOL SaveModified();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCubeMapDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CCubeMapDoc)
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern LPTSTR strCubeDir[CUBEMAP_TOTAL_DIR]; 

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CUBEMAPDOC_H__29C9064E_ACE2_4A7D_AF94_E8ADA0230AAB__INCLUDED_)
