// CubeMapSIze.cpp : implementation file
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LPTSTR strValidTextureSizes[] =
{
	_T("1"),
	_T("2"),
	_T("4"),
	_T("8"),
	_T("16"),
	_T("32"),
	_T("64"),
	_T("128"),
	_T("256"),
	_T("512"),
	_T("1024"),
	_T("2048"),
	_T("4096")
};

/////////////////////////////////////////////////////////////////////////////
// CCubeMapSize dialog


CCubeMapSize::CCubeMapSize(CWnd* pParent /*=NULL*/)
	: CDialog(CCubeMapSize::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCubeMapSize)
	//}}AFX_DATA_INIT
}


void CCubeMapSize::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCubeMapSize)
	DDX_Control(pDX, IDC_CUBE_MAP_WIDTH, m_CubeMapWidth);
	DDX_Control(pDX, IDC_CUBE_MAP_HEIGHT, m_CubeMapHeight);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCubeMapSize, CDialog)
	//{{AFX_MSG_MAP(CCubeMapSize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCubeMapSize message handlers

BOOL CCubeMapSize::OnInitDialog() 
{
	DWORD i;
	CDialog::OnInitDialog();

	m_CubeMapWidth.ResetContent();
	m_CubeMapHeight.ResetContent();

	for (i=0; i< sizeof(strValidTextureSizes) / sizeof(LPTSTR); i++)
	{
		m_CubeMapWidth.InsertString(i, strValidTextureSizes[i]);
		m_CubeMapHeight.InsertString(i, strValidTextureSizes[i]);
	}

	// default to 256x256
	m_CubeMapWidth.SetTopIndex(theApp.m_LastCubeSize.cx);
	m_CubeMapHeight.SetTopIndex(theApp.m_LastCubeSize.cy);

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCubeMapSize::OnOK() 
{
	UpdateData(TRUE);

	theApp.m_LastCubeSize.cx = m_CubeMapWidth.GetTopIndex();
	theApp.m_LastCubeSize.cy = m_CubeMapHeight.GetTopIndex();
	m_CubeMapSize.cx = 	(1 << theApp.m_LastCubeSize.cx);
	m_CubeMapSize.cy = 	(1 << theApp.m_LastCubeSize.cy);
	
	CDialog::OnOK();
}
