// DCM.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

TCHAR OpenFileName[2048];
TCHAR SaveFileName[2048];

TCHAR OpenFilter[] = {
	"All Files (*.*)\0" "*.*\0"
//	"DirectX Image Files (*.dds)\0" "*.dds\0"
	"Graphics Interchange Format (*.gif)\0" "*.gif\0"
	"Half-Life Model Files (*.mdl)\0" "*.mdl\0"
	"Homeworld Image Files (*.lif)\0" "*.lif\0"
	"Jpeg Files (*.jpe, *.jpg, *.jpeg)\0" "*.jpe;*.jpg;*.jpeg\0"
	"Microsoft Bitmap Files (*.bmp)\0" "*.bmp\0"
	"Microsoft Icon Files (*.ico)\0" "*.ico\0"
	"DevIL Files (*.oil)\0" "*.oil\0"
	"Portable AnyMap Files (*.pbm, *.pgm, *.pnm, *.ppm)\0" "*.pbm;*.pgm;*.pnm;*.ppm\0"
	"Portable Network Graphics Files (*.png)\0" "*.png\0"
	"Sgi Files (*.sgi)\0" "*.bw;*.rgb;*.rgba;*.sgi\0"
	"Targa Files (*.tga)\0" "*.tga\0"
	"Tiff Files (*.tif)\0" "*.tif;*.tiff\0"
	"Quake Wal Files (*.wal)\0" "*.wal\0"
	"ZSoft Pcx Files (*.pcx)\0" "*.pcx\0"
	"\0\0"
};

TCHAR SaveFilter[] = {
	"All Files (*.*)\0" "*.*\0"
	"C-Style Header (*.h)\0" "*.h\0"
//	"Direct X Files (*.dds)\0" "*.dds\0"
	"Jpeg Files (*.jpe, *.jpg, *.jpeg)\0" "*.jpe;*.jpg;*.jpeg\0"
	"Microsoft Bitmap Files (*.bmp)\0" "*.bmp\0"
	"DevIL Files (*.oil)\0" "*.oil\0"
	"Portable AnyMap Files (*.pbm, *.pgm, *.ppm)\0" "*.pbm;*.pgm;*.ppm\0"
	"Portable Network Graphics Files (*.png)\0" "*.png\0"
	"Sgi Files (*.sgi)\0" "*.bw;*.rgb;*.rgba;*.sgi\0"
	"Targa Files (*.tga)\0" "*.tga\0"
	"ZSoft Pcx Files (*.pcx)\0" "*.pcx\0"
	"\0\0"
};

OPENFILENAME Ofn = {
	sizeof(OPENFILENAME),
	0,
	NULL,
	OpenFilter,
	NULL,
	0,
	0,
	OpenFileName,
	2048,
	NULL,
	0,
	NULL,
	NULL,
	OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST,
	0,
	0,
	NULL,
	NULL,
	NULL,
	NULL
};

OPENFILENAME Sfn = {
	sizeof(OPENFILENAME),
	0,
	NULL,
	SaveFilter,
	NULL,
	0,
	0,
	SaveFileName,
	2048,
	NULL,
	0,
	NULL,
	NULL,
	OFN_PATHMUSTEXIST,
	0,
	0,
	NULL,
	NULL,
	NULL,
	NULL
};

/////////////////////////////////////////////////////////////////////////////
// CDCMApp

BEGIN_MESSAGE_MAP(CDCMApp, CWinApp)
	//{{AFX_MSG_MAP(CDCMApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDCMApp construction

CDCMApp::CDCMApp()
{
	m_GlobalSkipModified = FALSE;
	m_LastCubeSize.cx = 8;	// 1 << 8 = 256
	m_LastCubeSize.cy = 8;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDCMApp object

CDCMApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDCMApp initialization

BOOL CDCMApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	m_CurCubeDir = CUBEMAP_POS_X;

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Trinity Investments"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// initialize image libraries
	ilInit();
	iluInit();
	ilutInit();

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	m_pBMDocTemplate = new CMultiDocTemplate(
		IDR_BMTYPE,
		RUNTIME_CLASS(CBMDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CBMView));
	AddDocTemplate(m_pBMDocTemplate);

	m_pCMDocTemplate = new CMultiDocTemplate(
		IDR_CUBEMAP,
		RUNTIME_CLASS(CCubeMapDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CCubeMapView));
	AddDocTemplate(m_pCMDocTemplate);

	m_pDCMDocTemplate = new CMultiDocTemplate(
		IDR_CUBEMAP,
		RUNTIME_CLASS(CDiffCubeMapDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CDiffCubeMapView));
	AddDocTemplate(m_pDCMDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	Ofn.lpstrFilter = OpenFilter;
	Ofn.lpstrFile = OpenFileName;
	Ofn.lpstrTitle = "Open File";
	Ofn.hwndOwner = m_pMainWnd->GetSafeHwnd();
	Ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
	Ofn.nFilterIndex = GetProfileInt(_T("Settings"), _T("LastFilter"), 1);
	
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;

	cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDCMApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDCMApp message handlers


int CDCMApp::ExitInstance() 
{
	iFreeMem();
	
	return CWinApp::ExitInstance();
}
	

LPTSTR GetWildFilter(LPTSTR filters, int index)
{
	while (index > 0)
	{
		// not found?
		if (*filters == '\0')
			return NULL;

		// skip description string
		filters += _tcslen(filters)+1;
		// if not at the index we want skip filter string also
		if (index != 1)
		{
			filters += _tcslen(filters)+1;
		}
		index--;
	}

	return filters;
}

void CDCMApp::OnFileOpen() 
{
	sprintf(OpenFileName, "");
	if (!GetOpenFileName(&Ofn))
	{
		return;
	}

	WriteProfileInt(_T("Settings"), _T("LastFilter"), Ofn.nFilterIndex);
	m_pBMDocTemplate->OpenDocumentFile(Ofn.lpstrFile);
}
