// DCMView.h : interface of the CDCMView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DCMVIEW_H__F1A087FE_4BD8_4C46_BE2C_EE9DE76C96B1__INCLUDED_)
#define AFX_DCMVIEW_H__F1A087FE_4BD8_4C46_BE2C_EE9DE76C96B1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define TOPLEFT			0
#define TOPMIDDLE		1
#define TOPRIGHT		2
#define RIGHTMIDDLE		3
#define BOTTOMRIGHT		4
#define BOTTOMMIDDLE	5
#define BOTTOMLEFT		6
#define LEFTMIDDLE		7
#define MOVE			8
#define NUMCURSORS		(MOVE+1)
#define UNDEFINEDHANDLE	-1

class CDCMView : public CView
{
protected: // create from serialization only
	CDCMView();
	DECLARE_DYNCREATE(CDCMView)

// Attributes
public:
	CDCMDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDCMView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDCMView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
// attributes
	CRect m_IncludeEllipseRect;
	CRect m_ExcludeEllipseRect;
	BOOL m_LbuttonDown;
	BOOL m_bRectPlaced;
	HCURSOR m_OldCursor;
	HCURSOR cursors[NUMCURSORS];
	int	m_HandleTracking;
	CPoint m_MouseStart;

// Implementation
	void DrawSelections();
	void DrawHandles(CDC *pDC, const CRect &theRect);
	int CheckMouseOverHandles(const CRect &theRect, CPoint mousePos);
	int HitTest(CPoint point);
	void DeflateOuter(CRect diff, CPoint mousePos);
	void DeflateInner(CPoint diff, CPoint mousePos);


// Generated message map functions
protected:
	//{{AFX_MSG(CDCMView)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DCMView.cpp
inline CDCMDoc* CDCMView::GetDocument()
   { return (CDCMDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DCMVIEW_H__F1A087FE_4BD8_4C46_BE2C_EE9DE76C96B1__INCLUDED_)
